#include "Scenario.h"
#include "printError.h"

void writeScenario (const char* const scenarioFileName,
		    const char* const pt,const int scenarioSize)
{
  ofstream msc (scenarioFileName,ios::out|ios::noreplace);
  if (!msc)
    {//file$B$,:n@.$G$-$J$+$C$?!#(B
      printErrorCanNotCreate (scenarioFileName);
    }
  else
    {//file$B$,:n@.$G$-$?$N$G=q$-9~$`!#(B
      msc.write (pt,scenarioSize);
      if (msc.fail ())
	{
	  printErrorCanNotWrite (scenarioFileName);
	}
    }
  msc.close ();
}


void divide (Scenario& scenario,MaslInputStream& mms,const Bool isOutputSjis)
{
  for (const char* filename=scenario.getDataFilename ();
       filename!=NULL;
       filename=scenario.getDataFilename ())
    {
      cout << "creating \"";
      Scenario::writeSjis (cout,filename,strlen (filename),isOutputSjis);
      cout << "\"." << endl;

      ///////////////////data$BFI$_9~$_(B
      int dataSize=mms.get32 ();
      char* tmp=new char[dataSize];
      mms.read (tmp,dataSize);

      //////////////////////$B=q$-9~$`$?$a$N%U%!%$%k%*!<%W%s(B
      ofstream data (filename,ios::out|ios::noreplace);
      if (!data)
	{
	  printErrorCanNotCreate (filename);
	  data.close ();
	  delete[] tmp;
	  continue;
	}
      /////////////////data$B=q$-9~$_(B
      data.write (tmp,dataSize);
      if (data.fail ())
	{
	  printErrorCanNotWrite (filename);
	  data.close ();
	  delete[] tmp;
	  continue;
	}
      ////////////////fileclose
      data.close ();
      delete[] tmp;
    }
}
