#include "MaslOutputStream.h"
#include "Scenario.h"
#include "printError.h"

void addData (MaslOutputStream& mms,Scenario& scenario,
	      const char* const mmsFileName,const Bool isOutputSjis)
{
  //$B$3$3$+$i(B*.nak(*.ak5) *.pkn$B$H$$$&(Bdata$B$,=q$$$F$"$k!#(B
  //$B$G$=$N=g$K(Bdata$B$,3JG<$5$l$F$$$k$N$G$=$l$rFI$_9~$`(B
  //.$B$N$_$N9T$,Mh$l$P=*$j(B
  const char* filename=scenario.getDataFilename ();
  while (filename!=NULL)
    {
      MaslInputStream data (filename,ios::in|ios::nocreate);
      if (!data)
	{
	  printErrorCanNotOpen (filename);
	  //msc$B$r>C5n$9$k!#(B
	  exit (-1);
	}
      int dataSize=data.getFileSize ();
      cout << "now adding ";
      Scenario::writeSjis (cout,filename,strlen (filename),isOutputSjis);
      cout << " size=" << dataSize << endl;
      mms.put32 (dataSize);
      char* tmp=new char[dataSize];
      data.read (tmp,dataSize);
      mms.write (tmp,dataSize);
      delete[] tmp;
      if (mms.fail ())
	{
	  printErrorCanNotWrite (mmsFileName);
	  mms.close ();
	  data.close ();
	  exit (-1);
	}
      data.close ();
      filename=scenario.getDataFilename ();
    }
}
