/* 
        mmsmake.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <ctype.h>
#include <string.h>

#include "MaslOutputStream.h"
#include "MaslInputStream.h"
#include "MmsScenario.h"
#include "printError.h"
#include "makeCommon.h"

main (int argc,char** argv)
{
  if (argc<2 || argc>3)
    {
      cerr << "Usage:mmsmake file.msc [file.mms]" << endl;
      exit (-1);
    }

  const Bool isOutputSjis=False;//$BI8=`=PNO$K(Bsjis$B$r=PNO$9$k$+(B?
  //=False$B$@$H(Beuc$B$KJQ49$7$F=PNO(B

  const char* const scenarioFileName=argv[1];

  char* mmsFileName=NULL;
  if (argc==3)
    {
      mmsFileName=argv[2];
    }
  else
    {
      const int scenarioFileNameLength=strlen (scenarioFileName);
      mmsFileName=new char[scenarioFileNameLength+1];
      strcpy (mmsFileName,scenarioFileName);
      *(mmsFileName+scenarioFileNameLength-3)='m';
      *(mmsFileName+scenarioFileNameLength-2)='m';
      *(mmsFileName+scenarioFileNameLength-1)='s';
    }
  //////////////////////////////////////////////////////////file$BFI$_9~$_(B
  MaslInputStream msc (scenarioFileName,ios::in|ios::nocreate);
  if (!msc)
    {
      printErrorCanNotOpen (scenarioFileName);
      msc.close ();
      exit (-1);
    }
  int scenarioSize=msc.getFileSize ();
  char* pt=new char[scenarioSize];
  msc.read (pt,scenarioSize);
  msc.close ();
  
  ////////////file$B=q$-9~$_(B
  MaslOutputStream mms (mmsFileName,ios::out|ios::noreplace);
  if (!mms)
    {
      printErrorCanNotCreate (mmsFileName);
      exit (-1);
    }
  cout << "now creating ";
  Scenario::writeSjis (cout,mmsFileName,strlen (mmsFileName),isOutputSjis);
  cout << "." << endl;
    
  ///////////////header$B=q$-9~$_(B
  char magic[8]="MMS";
  memset (magic+3,0,5);
  mms.write (magic,8);
  if (mms.fail ())
    {
      printErrorCanNotWrite (mmsFileName);
      mms.close ();
      exit (-1);
    }
  
  //////////////scenario$B=q$-9~$_(B
  mms.put16 (scenarioSize);
  mms.write (pt,scenarioSize);
  if (mms.fail ())
    {
      printErrorCanNotWrite (mmsFileName);
      mms.close ();
      exit (-1);
    }
  
  //////////////scenario$B$N(Bcheck
  MmsScenario scenario(pt,scenarioSize);
  delete[] pt;
  scenario.showInfo ();
  
  /////////////////////////////////////////////////////ak5,pkn data$B=q$-9~$_(B
  addData (mms,scenario,mmsFileName,isOutputSjis);

  ///////////////////////$B=*$o$j(B
  cout << "completed" << endl;
  mms.close ();
  if (argc==2)
    delete[] mmsFileName;
  exit (0);
}

