/* 
        mmsdiv.cc

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <ctype.h>
#include <string.h>

#include "MaslOutputStream.h"
#include "MaslInputStream.h"
#include "MaslScenario.h"
#include "printError.h"
#include "divideCommon.h"

main (int argc,char** argv)
{
  if (argc<2 || argc>3)
    {
      cerr << "Usage:msldiv file.msl [file.mas]" << endl;
      exit (-1);
    }

  const Bool isOutputSjis=False;//$BI8=`=PNO$K(Bsjis$B$r=PNO$9$k$+(B?
  //=False$B$@$H(Beuc$B$KJQ49$7$F=PNO(B

  const char* const mmsFileName=argv[1];
  char* scenarioFileName=NULL;
  if (argc==3)
    {
      scenarioFileName=argv[2];
    }
  else
    {
      const int mmsFileNameLength=strlen (mmsFileName);
      scenarioFileName=new char[mmsFileNameLength+1];
      strcpy (scenarioFileName,mmsFileName);
      *(scenarioFileName+mmsFileNameLength-3)='m';
      *(scenarioFileName+mmsFileNameLength-2)='a';
      *(scenarioFileName+mmsFileNameLength-1)='s';
    }

  ///////////////////////////////////////////////////
  MaslInputStream mms (mmsFileName,ios::in|ios::nocreate);
  if (!mms)
    {
      cerr << mmsFileName << " is not found." << endl;
      exit (-1);
    }
  
  char magic[8];
  mms.read (magic,8);
  if (magic[0]!='M' || magic[1]!='S' || magic[2]!='L')
    {
      cerr << "this file is not for MASL." << endl;
      cerr << "Is file broken?" << endl;
      exit (-1);
    }

  ////////////////////////scenario$B$N=q$-=P$7(B
  cout << "now creating scenario file.:";
  Scenario::writeSjis (cout,scenarioFileName,strlen (scenarioFileName),
		       isOutputSjis);
  cout << endl;
  int scenarioSize=mms.get16 ();
  char* pt=new char[scenarioSize];
  mms.read (pt,scenarioSize);
  writeScenario (scenarioFileName,pt,scenarioSize);
  MaslScenario scenario (pt,scenarioSize);
  delete[] pt;

  /////////////////////////////data(nak,pkn)$B$N=q$-=P$7(B
  scenario.showInfo ();
  cout << "now creating data(.nak or .pkn)." << endl;
  divide (scenario,mms,isOutputSjis);
  
  /////////////////////////////////$B8e;OKv!#(B
  mms.close ();
  if (argc==2)
    delete[] scenarioFileName;
}
